unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ActnList, ComCtrls, StdCtrls, ExtCtrls, DBCtrls, Grids,
  DBGrids, inifiles, DB, registry, shlobj;

type
  TformMenuPrincipal = class(TForm)
    ActionList1: TActionList;
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Ayuda1: TMenuItem;
    actBaseDatos: TAction;
    Basededatos1: TMenuItem;
    actSalir: TAction;
    N1: TMenuItem;
    Salir1: TMenuItem;
    be: TStatusBar;
    tab: TPageControl;
    tabExploracion: TTabSheet;
    tabBaseDatos: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    txtRutaInicial: TEdit;
    bRuta: TButton;
    GroupBox3: TGroupBox;
    opBuscarClaves: TCheckBox;
    opBuscarFicheros: TCheckBox;
    opBuscarProcesos: TCheckBox;
    tabConfiguracion: TTabSheet;
    tablaDatos: TDBGrid;
    tablaDatosDetalle: TDBGrid;
    Splitter1: TSplitter;
    actExplorar: TAction;
    actConfiguracion: TAction;
    Configuracin1: TMenuItem;
    Exploracin1: TMenuItem;
    GroupBox4: TGroupBox;
    opIniciarWindows: TCheckBox;
    opBuscarActualizacionesInicio: TCheckBox;
    opIniciarOculta: TCheckBox;
    tabAnalisisProgramado: TTabSheet;
    GroupBox5: TGroupBox;
    actAnalisisProgramado: TAction;
    Anlisisprogramado1: TMenuItem;
    GroupBox6: TGroupBox;
    opTipoExaustiva: TRadioButton;
    opTipoBD: TRadioButton;
    Button1: TButton;
    actIniciarExploracion: TAction;
    tabResultado: TTabSheet;
    Panel1: TPanel;
    actSeleccionarTodos: TAction;
    Button3: TButton;
    dbNavegadorResultado: TDBNavigator;
    DBGrid3: TDBGrid;
    Button4: TButton;
    actEliminar: TAction;
    Panel2: TPanel;
    Button5: TButton;
    actNuevaAccion: TAction;
    Panel3: TPanel;
    Button6: TButton;
    actNuevoElemento: TAction;
    DBNavigator1: TDBNavigator;
    DBNavigator3: TDBNavigator;
    Button7: TButton;
    actModificarElemento: TAction;
    actModificarAccion: TAction;
    Button8: TButton;
    Panel4: TPanel;
    lInfo: TLabel;
    Shape1: TShape;
    bp: TProgressBar;
    actDesmarcarTodo: TAction;
    Button2: TButton;
    Button9: TButton;
    actMarcar: TAction;
    Button10: TButton;
    actDesmarcar: TAction;
    actResultado: TAction;
    Resultadoexploracin1: TMenuItem;
    opBuscarVentanas: TCheckBox;
    opBuscarCookies: TCheckBox;
    opBuscarFavoritos: TCheckBox;
    GroupBox2: TGroupBox;
    opPapeleraReciclaje: TCheckBox;
    lNum: TLabel;
    lNumDe: TLabel;
    tabTodasAcciones: TTabSheet;
    DBGrid1: TDBGrid;
    DBNavigator2: TDBNavigator;
    procedure actSalirExecute(Sender: TObject);
    procedure actBaseDatosExecute(Sender: TObject);
    procedure actExplorarExecute(Sender: TObject);
    procedure actConfiguracionExecute(Sender: TObject);
    procedure actAnalisisProgramadoExecute(Sender: TObject);
    procedure actIniciarExploracionExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure actSeleccionarTodosExecute(Sender: TObject);
    procedure actNuevoElementoExecute(Sender: TObject);
    procedure actNuevaAccionExecute(Sender: TObject);
    procedure actModificarElementoExecute(Sender: TObject);
    procedure actModificarAccionExecute(Sender: TObject);
    procedure actEliminarExecute(Sender: TObject);
    procedure actDesmarcarTodoExecute(Sender: TObject);
    procedure actMarcarExecute(Sender: TObject);
    procedure actDesmarcarExecute(Sender: TObject);
    procedure actResultadoExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

uses UnidadModuloDatos, UnidadElemento, UnidadElementoAccion;

{$R *.dfm}

//Obtiene la ruta de las carpetas del sistema
function obtenerCarpeta (Folder: Integer): String;
var
  FilePath : array[0..MAX_PATH] of char;
begin
  SHGetSpecialFolderPath(0, FilePath, Folder , False);
  Result := FilePath;
end;

function obtenerDirectorioWindows : TFileName;
var
  WinDir: array [0..MAX_PATH-1] of char;
begin
  SetString(Result, WinDir, GetWindowsDirectory(WinDir, MAX_PATH));
  //if Result = '' then
  //  raise Exception.Create(SysErrorMessage(GetLastError));
end;

function obtenerDirectorioSistema : TFileName;
var
  SysDir: array [0..MAX_PATH-1] of char;
begin
  SetString(Result, SysDir, GetSystemDirectory(SysDir, MAX_PATH));
  //if Result = '' then
  //  raise Exception.Create(SysErrorMessage(GetLastError));
end;

function obtenerDirectorioProgramas : TFileName;
begin
  with TRegistry.Create do
  try
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion', false);
    result := ReadString('ProgramFilesDir');
    CloseKey;
  finally
    free;
  end;
end;

function obtenerDirectorioArchivosComunes : TFileName;
begin
  with TRegistry.Create do
  try
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion', false);
    result := ReadString('CommonFilesDir');
    CloseKey;
  finally
    free;
  end;
end;

function obtenerDirectorioProgramasInternet : TFileName;
begin
  result := obtenerDirectorioWindows + '\Downloaded Program Files';
end;


function obtenerDirectorioTemporal : TFileName;
var
  TmpDir: array [0..MAX_PATH-1] of char;
begin
 try
  SetString(Result, TmpDir, GetTempPath(MAX_PATH, TmpDir));
  if not DirectoryExists(Result) then
   if not CreateDirectory(PChar(Result), nil) then begin
    Result := IncludeTrailingBackslash(obtenerDirectorioWindows) + 'TEMP';
    if not DirectoryExists(Result) then
     if not CreateDirectory(Pointer(Result), nil) then begin
      Result := ExtractFileDrive(Result) + '\TEMP';
      if not DirectoryExists(Result) then
       if not CreateDirectory(Pointer(Result), nil) then begin
        Result := ExtractFileDrive(Result) + '\TMP';
        if not DirectoryExists(Result) then
         if not CreateDirectory(Pointer(Result), nil) then begin
          //raise Exception.Create(SysErrorMessage(GetLastError));
         end;
       end;
     end;
   end;
  except
    Result := '';
    raise;
  end;
end;




//obtiene subcarpetas a partir de la carpeta especificada
procedure obtenerSubcarpetas(Folder:string; sList:TStringList);
 var
  sr:TSearchRec;
begin
  if FindFirst(Folder+'*.*',faDirectory,sr)=0 then
   try
    repeat
      if(sr.Attr and faDirectory)=faDirectory then
       sList.Add(sr.Name);
    until FindNext(sr)<>0;
   finally
    FindClose(sr);
   end;
end;

//obtiene los ficheros de una carpeta determinada
procedure buscarFicheros (filtro, carpeta : string;
    Recursiva : boolean; lstResultado : TStringList);
var
  sr : TSearchRec;
  i : integer;
  sListaCarpetas : TStringList;
begin
  if FindFirst(carpeta + Filtro, faAnyFile, sr) = 0 then
  begin
    repeat
      if (sr.Name <> '.') and (sr.Name <> '..') then
        lstResultado.Add (carpeta + sr.Name);
    until FindNext(sr) <> 0;
  end;
  FindClose(sr);
  if Recursiva then
  begin
    sListaCarpetas := TStringList.Create;
    try
      obtenerSubcarpetas(carpeta, sListaCarpetas);
      for i := 0 to sListaCarpetas.Count - 1 do
      begin
        if (sListaCarpetas[i] <> '.') and (sListaCarpetas[i] <> '..') then
        begin
          Application.ProcessMessages;
          buscarFicheros(filtro, IncludeTrailingPathDelimiter(carpeta +
              sListaCarpetas[i]), Recursiva, lstResultado);
        end;
      end;
    finally
      sListaCarpetas.Free;
    end;
  end;
end;

procedure TformMenuPrincipal.actSalirExecute(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.actBaseDatosExecute(Sender: TObject);
begin
  tabBaseDatos.Show;
end;

procedure TformMenuPrincipal.actExplorarExecute(Sender: TObject);
begin
  tabExploracion.Show;
end;

procedure TformMenuPrincipal.actConfiguracionExecute(Sender: TObject);
begin
  tabConfiguracion.Show;
end;

procedure TformMenuPrincipal.actAnalisisProgramadoExecute(Sender: TObject);
begin
  tabAnalisisProgramado.Show;
end;

procedure TformMenuPrincipal.actIniciarExploracionExecute(Sender: TObject);
var
  accion, cookieActual : string;
  datosAccion, clave, claveValor, claveRootkey, carpetaSistema : string;
  numero, i : integer;
  existeClave : boolean;
  lista : TStringList;
  cCookies, cEscritorio, cProgramasMenuInicio, cImpresoras,
  cMisDocumentos, cFavoritos, cInicioProgramasInicio, cDocRecientes : string;
  cEnviarA, cMenuInicio, cEntornoRed, cFuentes, cPlantillas,
  cProgramasMenuInicioTodos, cInicioProgramasInicioTodos : string;
  cEscritorioTodos, cFavoritosTodos, cDatosProgramas,
  cArchivosTemporalesInternet, cHistorial, cTemporal : string;
  cWindows, cSistema, cArchivosPrograma, cArchivosComunes, cProgramasInternet : string;
begin
  dbNavegadorResultado.Visible := false;
  actMarcar.Enabled := false;
  actDesmarcarTodo.Enabled := false;
  actSeleccionarTodos.Enabled := false;
  actDesmarcar.Enabled := false;
  actEliminar.Enabled := false;
  lInfo.Font.Color := clBlack;
  tabResultado.Show;
  lInfo.Caption := 'Iniciando bsqueda que software malicioso...';
  linfo.Refresh;
  //abrimos las tablas
  dm.tDatosDeResultado.Open;
  dm.tDatos.Open;
  dm.tDatosDe.Open;

  bp.Visible := true;
  bp.Min := 0;
  bp.Max := dm.tDatosDe.RecordCount;
  bp.Position := 0;
  bp.Refresh;
  Refresh;

  //eliminamos resultados anteriores de la BD
  dm.tc.Close;
  dm.tc.SQL.Clear;
  dm.tc.SQL.Add('DELETE FROM DatosDetalleResultado');
  dm.tc.ExecSQL;

  dm.tc.Close;
  dm.tc.SQL.Clear;
  dm.tc.SQL.Add('SELECT dd.Accion, dd.DatoAccion, dd.CodigoDato, dd.RootKey, ');
  dm.tc.SQL.Add('dd.Clave, dd.ClaveValor, dd.CarpetaSistema, d.Nombre  ');
  dm.tc.SQL.Add('FROM DatosDetalle dd, Datos d WHERE dd.CodigoDato=d.Codigo');
  dm.tc.Open;

  //obtenemos las rutas de todas las carpetas del sistema
  cCookies := obtenerCarpeta (CSIDL_COOKIES);
  cEscritorio := obtenerCarpeta (CSIDL_DESKTOP);
  cProgramasMenuInicio := obtenerCarpeta (CSIDL_PROGRAMS);
  cImpresoras := obtenerCarpeta (CSIDL_PRINTERS);
  cMisDocumentos :=  obtenerCarpeta (CSIDL_PERSONAL);
  cFavoritos := obtenerCarpeta (CSIDL_FAVORITES);
  cInicioProgramasInicio := obtenerCarpeta (CSIDL_STARTUP);
  cDocRecientes := obtenerCarpeta (CSIDL_RECENT);
  cEnviarA := obtenerCarpeta (CSIDL_SENDTO);
  cMenuInicio := obtenerCarpeta (CSIDL_STARTMENU);
  cEscritorio := obtenerCarpeta (CSIDL_DESKTOPDIRECTORY);
  cEntornoRed := obtenerCarpeta (CSIDL_NETHOOD);
  cFuentes := obtenerCarpeta (CSIDL_FONTS);
  cPlantillas := obtenerCarpeta (CSIDL_TEMPLATES);
  cProgramasMenuInicioTodos := obtenerCarpeta (CSIDL_COMMON_STARTMENU);
  // obtenerCarpeta (CSIDL_COMMON_PROGRAMS));
  cInicioProgramasInicioTodos := obtenerCarpeta (CSIDL_COMMON_STARTUP);
  cEscritorioTodos := obtenerCarpeta (CSIDL_COMMON_DESKTOPDIRECTORY);
  cFavoritosTodos := obtenerCarpeta (CSIDL_COMMON_FAVORITES);
  cDatosProgramas := obtenerCarpeta (CSIDL_APPDATA);
  cArchivosTemporalesInternet := obtenerCarpeta (CSIDL_INTERNET_CACHE);
  cHistorial := obtenerCarpeta (CSIDL_HISTORY);
  cWindows := obtenerDirectorioWindows;
  cSistema := obtenerDirectorioSistema;
  cArchivosPrograma := obtenerDirectorioProgramas;
  cTemporal := obtenerDirectorioTemporal;
  cArchivosComunes := obtenerDirectorioArchivosComunes;
  cProgramasInternet := obtenerDirectorioProgramasInternet;
  
  numero := 0;
  while not dm.tc.Eof do
  begin
    bp.Position := dm.tc.RecNo;
    bp.Refresh;
    lInfo.Caption := 'Buscando ' + dm.tc.fieldbyname ('Nombre').Value;
    lInfo.Refresh;
    if Not varisnull(dm.tc.FieldByName('Accion').Value) then
      accion := dm.tc.FieldByName('Accion').Value
    else
      accion := '';
    if Not varisnull(dm.tc.FieldByName('DatoAccion').Value) then
      datosAccion := dm.tc.FieldByName('DatoAccion').Value
    else
      datosAccion := '';
    if Not varisnull(dm.tc.FieldByName('CarpetaSistema').Value) then
      carpetaSistema := dm.tc.FieldByName('CarpetaSistema').Value
    else
      carpetaSistema := '';

    //Ficheros y carpetas
    if opBuscarFicheros.Checked then
    begin
      if accion = 'Buscar Carpeta' then
      begin
        if DirectoryExists (datosaccion) then
        begin
          numero := numero + 1;
          dm.tDatosDeResultado.Insert;
          dm.tDatosDeResultado.FieldByName('DatoAccion').Value := datosAccion;
          dm.tDatosDeResultado.FieldByName('CodigoDato').Value :=
              dm.tc.fieldbyname('CodigoDato').value;
          dm.tDatosDeResultado.FieldByName('Nombre').Value :=
              dm.tc.fieldbyname('Nombre').value;
          dm.tDatosDeResultado.FieldByName('Accion').Value := Accion;
          dm.tDatosDeResultado.FieldByName('Eliminar').Value := False;
          dm.tDatosDeResultado.Post;
        end;
      end;
      if carpetaSistema = 'Archivos temporales de Internet' then
        datosAccion := cArchivosTemporalesInternet + '\' + datosAccion;
      if carpetaSistema = 'Carpeta Inicio del Men Programas' then
        datosAccion := cProgramasMenuInicio + '\' + datosAccion;
      if carpetaSistema = 'Carpeta Inicio del men Programas de todos los usuarios' then
        datosAccion := cInicioProgramasInicioTodos + '\' + datosAccion;
      if carpetaSistema = 'Cookies' then
        datosAccion := cCookies + '\' + datosAccion;
      if carpetaSistema = 'Datos de programa' then
        datosAccion := cDatosProgramas+ '\' + datosAccion;
      if carpetaSistema = 'Documentos Recientes' then
        datosAccion := cDocRecientes + '\' + datosAccion;
      if carpetaSistema = 'Enviar a' then
        datosAccion := cEnviarA + '\' + datosAccion;
      if carpetaSistema = 'Escritorio' then
        datosAccion := cEscritorio + '\' + datosAccion;
      if carpetaSistema = 'Escritorio de todos los usuarios' then
        datosAccion := cEscritorioTodos + '\' + datosAccion;
      if carpetaSistema = 'Favoritos' then
        datosAccion := cFavoritos + '\' + datosAccion;
      if carpetaSistema = 'Favoritos de todos los usuarios' then
        datosAccion := cFavoritosTodos + '\' + datosAccion;
      if carpetaSistema = 'Fuentes' then
        datosAccion := cFuentes + '\' + datosAccion;
      if carpetaSistema = 'Men inicio de todos los usuarios' then
        datosAccion := cProgramasMenuInicioTodos + '\' + datosAccion;
      if carpetaSistema = 'Mis Documentos' then
        datosAccion := cMisDocumentos + '\' + datosAccion;
      if carpetaSistema = 'Plantillas' then
        datosAccion := cPlantillas + '\' + datosAccion;
      if carpetaSistema = 'Programas del men Inicio de todos los usuarios' then
        datosAccion := cProgramasMenuInicioTodos + '\' + datosAccion;
      if carpetaSistema = 'Programas Men Inicio' then
        datosAccion := cProgramasMenuInicio + '\' + datosAccion;
      if carpetaSistema = 'Sistema' then
        datosAccion := cSistema + '\' + datosAccion;
      if carpetaSistema = 'Windows' then
        datosAccion := cWindows + '\' + datosAccion;
      if carpetaSistema = 'Archivos de programa' then
        datosAccion := cArchivosPrograma + '\' + datosAccion;
      if carpetaSistema = 'Archivos comunes' then
        datosAccion := cArchivosComunes + '\' + datosAccion;
      if carpetaSistema = 'Directorio Temporal' then
        datosAccion := cTemporal + '\' + datosAccion;
      if carpetaSistema = 'Programas descargados de Internet' then
        datosAccion := cProgramasInternet + '\' + datosAccion;
      if accion = 'Buscar Carpeta (carpeta del sistema)' then
      begin
        if DirectoryExists (datosaccion) then
        begin
          numero := numero + 1;
          dm.tDatosDeResultado.Insert;
          dm.tDatosDeResultado.FieldByName('DatoAccion').Value := datosAccion;
          dm.tDatosDeResultado.FieldByName('CodigoDato').Value :=
              dm.tc.fieldbyname('CodigoDato').value;
          dm.tDatosDeResultado.FieldByName('Nombre').Value :=
              dm.tc.fieldbyname('Nombre').value;
          dm.tDatosDeResultado.FieldByName('Accion').Value := Accion;
          dm.tDatosDeResultado.FieldByName('Eliminar').Value := False;
          dm.tDatosDeResultado.Post;
        end;
      end;
      if accion = 'Buscar Fichero (carpeta del sistema)' then
      begin
        if FileExists (datosaccion) then
        begin
          numero := numero + 1;
          dm.tDatosDeResultado.Insert;
          dm.tDatosDeResultado.FieldByName('DatoAccion').Value := datosAccion;
          dm.tDatosDeResultado.FieldByName('CodigoDato').Value :=
              dm.tc.fieldbyname('CodigoDato').value;
          dm.tDatosDeResultado.FieldByName('Nombre').Value :=
              dm.tc.fieldbyname('Nombre').value;
          dm.tDatosDeResultado.FieldByName('Accion').Value := Accion;
          dm.tDatosDeResultado.FieldByName('Eliminar').Value := False;
          dm.tDatosDeResultado.Post;
        end;
      end;

      //sin terminar
      if accion = 'Buscar Carpeta (exaustivo)' then
      begin
        if DirectoryExists (datosaccion) then
        begin
          numero := numero + 1;
          dm.tDatosDeResultado.Insert;
          dm.tDatosDeResultado.FieldByName('DatoAccion').Value := datosAccion;
          dm.tDatosDeResultado.FieldByName('CodigoDato').Value :=
              dm.tc.fieldbyname('CodigoDato').value;
          dm.tDatosDeResultado.FieldByName('Nombre').Value :=
              dm.tc.fieldbyname('Nombre').value;
          dm.tDatosDeResultado.FieldByName('Accion').Value := Accion;
          dm.tDatosDeResultado.FieldByName('Eliminar').Value := False;
          dm.tDatosDeResultado.Post;
        end;
      end;

      if accion = 'Buscar Fichero' then
      begin
        if FileExists (datosaccion) then
        begin
          numero := numero + 1;
          dm.tDatosDeResultado.Insert;
          dm.tDatosDeResultado.FieldByName('DatoAccion').Value := datosAccion;
          dm.tDatosDeResultado.FieldByName('CodigoDato').Value :=
              dm.tc.fieldbyname('CodigoDato').value;
          dm.tDatosDeResultado.FieldByName('Nombre').Value :=
              dm.tc.fieldbyname('Nombre').value;
          dm.tDatosDeResultado.FieldByName('Accion').Value := Accion;
          dm.tDatosDeResultado.FieldByName('Eliminar').Value := False;
          dm.tDatosDeResultado.Post;
        end;
      end;

      //Sin terminar
      if accion = 'Buscar Fichero (exaustivo)' then
      begin
        if FileExists (datosaccion) then
        begin
          numero := numero + 1;
          dm.tDatosDeResultado.Insert;
          dm.tDatosDeResultado.FieldByName('DatoAccion').Value := datosAccion;
          dm.tDatosDeResultado.FieldByName('CodigoDato').Value :=
              dm.tc.fieldbyname('CodigoDato').value;
          dm.tDatosDeResultado.FieldByName('Nombre').Value :=
              dm.tc.fieldbyname('Nombre').value;
          dm.tDatosDeResultado.FieldByName('Accion').Value := Accion;
          dm.tDatosDeResultado.FieldByName('Eliminar').Value := False;
          dm.tDatosDeResultado.Post;
        end;
      end;
    end;

    //Registro
    if opBuscarClaves.Checked then
    begin
      if accion = 'Buscar Clave Registro' then
      begin
        //buscamos la clave de registro o el valor
        if not varisnull(dm.tc.FieldByName('RootKey').Value) then
          claveRootkey := dm.tc.FieldByName('RootKey').Value
        else
          claveRootkey := '';
        if not varisnull(dm.tc.FieldByName('Clave').Value) then
          clave := dm.tc.FieldByName('Clave').Value
        else
          clave := '';
        if not varisnull(dm.tc.FieldByName('ClaveValor').Value) then
          claveValor := dm.tc.FieldByName('ClaveValor').Value
        else
          claveValor := '';

        with TRegistry.Create do
        try
          if claveRootkey = 'HKEY_CLASSES_ROOT' then
            RootKey := HKEY_CLASSES_ROOT;
          if claveRootkey = 'HKEY_CURRENT_USER' then
            RootKey := HKEY_CURRENT_USER;
          if claveRootkey = 'HKEY_LOCAL_MACHINE' then
            RootKey := HKEY_LOCAL_MACHINE;
          if claveRootkey = 'HKEY_USERS' then
            RootKey := HKEY_USERS;
          if claveRootkey = 'HKEY_CURRENT_CONFIG' then
            RootKey := HKEY_CURRENT_CONFIG;
          if (claveValor = '') and (KeyExists(clave)) then
            existeClave := true
          else
          begin
            if OpenKey(clave,false) then
              existeClave := ValueExists(claveValor)
            else
              existeClave := false;
          end;
          if existeClave then
          begin
            numero := numero + 1;
            dm.tDatosDeResultado.Insert;
            dm.tDatosDeResultado.FieldByName('DatoAccion').Value := datosAccion;
            dm.tDatosDeResultado.FieldByName('CodigoDato').Value :=
                dm.tc.fieldbyname('CodigoDato').value;
            dm.tDatosDeResultado.FieldByName('Nombre').Value :=
                dm.tc.fieldbyname('Nombre').value;
            dm.tDatosDeResultado.FieldByName('RootKey').Value := claveRootkey;
            dm.tDatosDeResultado.FieldByName('Clave').Value := clave;
            dm.tDatosDeResultado.FieldByName('ClaveValor').Value := claveValor;
            dm.tDatosDeResultado.FieldByName('Accion').Value := Accion;
            dm.tDatosDeResultado.FieldByName('Eliminar').Value := False;
            dm.tDatosDeResultado.Post;
          end;
          CloseKey;
        finally
          Free;
        end;
      end;
    end;

    //Procesos
    //sin terminar
    if opBuscarProcesos.Checked then
    begin
      if accion = 'Buscar Proceso' then
      begin

      end;
    end;

    //Ventanas
    //sin terminar
    if opBuscarVentanas.Checked then
    begin
      if accion = 'Buscar Ventana' then
      begin

      end;
    end;


    //Cookies
    if opBuscarCookies.Checked then
    begin
      if accion = 'Buscar Cookie' then
      begin
        lista := TStringList.Create;
        buscarFicheros('*.*', cCookies + '\', true, lista); //buscamos todas las cookies
        for i := 0 to lista.Count - 1 do
        begin
          cookieActual := lista.Strings[i];
          if Pos(datosAccion, cookieActual) <> 0 then
          begin
            numero := numero + 1;
            dm.tDatosDeResultado.Insert;
            dm.tDatosDeResultado.FieldByName('DatoAccion').Value := cookieActual;
            dm.tDatosDeResultado.FieldByName('CodigoDato').Value :=
                dm.tc.fieldbyname('CodigoDato').value;
            dm.tDatosDeResultado.FieldByName('Nombre').Value :=
                dm.tc.fieldbyname('Nombre').value;
            dm.tDatosDeResultado.FieldByName('Accion').Value := Accion;
            dm.tDatosDeResultado.FieldByName('Eliminar').Value := False;
            dm.tDatosDeResultado.Post;
          end;
        end;
      end;
    end;

    //Favoritos
    if opBuscarFavoritos.Checked then
    begin
      if (accion = 'Buscar Favoritos (URL)') or
          (accion = 'Buscar Favoritos (Carpeta)') then
      begin
        if accion = 'Buscar Favoritos (URL)' then
        begin
          if FileExists(cFavoritos + '\' + datosAccion) then
          begin
            numero := numero + 1;
            dm.tDatosDeResultado.Insert;
            dm.tDatosDeResultado.FieldByName('DatoAccion').Value := cFavoritos
                + '\' + datosAccion;
            dm.tDatosDeResultado.FieldByName('CodigoDato').Value :=
                dm.tc.fieldbyname('CodigoDato').value;
            dm.tDatosDeResultado.FieldByName('Nombre').Value :=
                dm.tc.fieldbyname('Nombre').value;
            dm.tDatosDeResultado.FieldByName('Accion').Value := Accion;
            dm.tDatosDeResultado.FieldByName('Eliminar').Value := False;
            dm.tDatosDeResultado.Post;
          end;
        end;
        if accion = 'Buscar Favoritos (Carpeta)' then
        begin
          if DirectoryExists(cFavoritos + '\' + datosAccion) then
          begin
            numero := numero + 1;
            dm.tDatosDeResultado.Insert;
            dm.tDatosDeResultado.FieldByName('DatoAccion').Value := cFavoritos
                + '\' + datosAccion;
            dm.tDatosDeResultado.FieldByName('CodigoDato').Value :=
                dm.tc.fieldbyname('CodigoDato').value;
            dm.tDatosDeResultado.FieldByName('Nombre').Value :=
                dm.tc.fieldbyname('Nombre').value;
            dm.tDatosDeResultado.FieldByName('Accion').Value := Accion;
            dm.tDatosDeResultado.FieldByName('Eliminar').Value := False;
            dm.tDatosDeResultado.Post;
          end;
        end;
      end;
    end;


    if numero > 0 then
    begin
      be.Panels[1].Text := inttostr(numero) + ' elementos maliciosos encontrados';
      be.Refresh;
    end;
    dm.tc.Next;
  end;
  dm.tDatosDeResultado.Refresh;
  if numero > 0 then
  begin
    lInfo.Caption := 'El proceso ha finalizado. Se han encontrado: ' +
        inttostr(numero) + ' elementos maliciosos';
    lInfo.Font.Color := clMaroon;
    actSeleccionarTodos.Enabled := true;
    actDesmarcarTodo.Enabled := true;
    actEliminar.Enabled := true;
    dbNavegadorResultado.Visible := true;
    actMarcar.Enabled := true;
    actDesmarcar.Enabled := true;
  end
  else
  begin
    lInfo.Caption := 'El proceso ha finalizado. No se han encontrado elementos maliciosos.';
    lInfo.Font.Color := clGreen;
  end;
  lInfo.Refresh;
  bp.Visible := false;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    txtRutaInicial.Text := ReadString ('Ruta', 'Ruta inicial', 'C:\');
    opBuscarClaves.Checked := readBool ('Buscar elementos', 'Claves de registro', false);
    opBuscarProcesos.Checked := readBool ('Buscar elementos', 'Procesos', false);
    opBuscarFicheros.Checked := readBool ('Buscar elementos', 'Carpetas y ficheros', true);
    opBuscarVentanas.Checked := readBool ('Buscar elementos', 'Ventanas', false);
    opBuscarCookies.Checked := readBool ('Buscar elementos', 'Cookies', false);
    opBuscarFavoritos.Checked := readBool ('Buscar elementos', 'Favoritos', false);    
    opTipoExaustiva.Checked := readBool ('Tipo exploracin', 'Exaustivo', false);
    opTipoBD.Checked := readBool ('Tipo exploracin', 'Analizar slo elementos de base de datos', true);
    opIniciarWindows.Checked := readBool ('Configuracin', 'Iniciar con Windows', false);
    opBuscarActualizacionesInicio.Checked := readBool ('Configuracin', 'Buscar actualizaciones al inicio', false);
    opIniciarOculta.Checked := readBool ('Configuracin', 'Iniciar oculta en BT', false);
    opPapeleraReciclaje.Checked := ReadBool ('Configuracin', 'Enviar a papelera', true);
  finally
    free;
  end;
  dm.tDatosDe.Open;
  dm.tDatosDe2.Open;
  dm.tDatos.Open;
end;

procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    WriteString ('Ruta', 'Ruta inicial', txtRutaInicial.Text);
    WriteBool ('Buscar elementos', 'Claves de registro', opBuscarClaves.Checked);
    WriteBool ('Buscar elementos', 'Procesos', opBuscarProcesos.Checked);
    WriteBool ('Buscar elementos', 'Carpetas y ficheros', opBuscarFicheros.Checked);
    WriteBool ('Buscar elementos', 'Ventanas', opBuscarVentanas.Checked);
    WriteBool ('Buscar elementos', 'Cookies', opBuscarCookies.Checked);
    WriteBool ('Buscar elementos', 'Favoritos', opBuscarFavoritos.Checked);    
    WriteBool ('Tipo exploracin', 'Exaustivo', opTipoExaustiva.Checked);
    WriteBool ('Tipo exploracin', 'Analizar slo elementos de base de datos', opTipoBD.Checked);
    WriteBool ('Configuracin', 'Iniciar con Windows', opIniciarWindows.Checked);
    WriteBool ('Configuracin', 'Buscar actualizaciones al inicio', opBuscarActualizacionesInicio.Checked);
    WriteBool ('Configuracin', 'Iniciar oculta en BT', opIniciarOculta.Checked);
    WriteBool ('Configuracin', 'Enviar a papelera', opPapeleraReciclaje.Checked);
  finally
    free;
  end;
end;

procedure TformMenuPrincipal.actSeleccionarTodosExecute(Sender: TObject);
begin
  dm.tc.Close;
  dm.tc.SQL.Clear;
  dm.tc.SQL.Add('UPDATE DatosDetalleResultado SET Eliminar=True');
  dm.tc.ExecSQL;
  dm.tDatosDeResultado.Refresh;
end;

procedure TformMenuPrincipal.actNuevoElementoExecute(Sender: TObject);
begin
  dm.tDatos.Insert;
  dm.tDatos.FieldByName('Fecha').Value := date;
  dm.tDatos.FieldByName('Version').Value := '1';
  formElementoMalware.ShowModal;
end;

procedure TformMenuPrincipal.actNuevaAccionExecute(Sender: TObject);
var
  f : tform;
begin
  if dm.tDatos.State in [dsEdit, dsInsert] then
    dm.tDatos.Post;
  if (dm.tDatos.FieldByName('Codigo').Value = '') or
      (dm.tDatos.FieldByName('Codigo').Value = null) then
    MessageDlg('Antes de introducir una accin debe introducir un ' +
        'elemento (software malicioso)', mtWarning, [mbok], 0)
  else
  begin
    dm.tDatosDe.Insert;
    dm.tDatosDe.FieldByName('CodigoDato').Value :=
        dm.tDatos.fieldbyname('Codigo').Value;
    dm.tDatosDe.FieldByName('Accion').Value := 'Buscar Fichero';
    F := application.findcomponent('formElementoAccion') as TForm;
    if Assigned(F) then
        f.showmodal
    else
    begin
      application.createform(tformElementoAccion, formElementoAccion);
      formElementoAccion.showmodal;
    end;
  end;
end;

procedure TformMenuPrincipal.actModificarElementoExecute(Sender: TObject);
begin
  dm.tDatos.Edit;
  formElementoMalware.ShowModal;
end;

procedure TformMenuPrincipal.actModificarAccionExecute(Sender: TObject);
var
  f : TForm;
begin
  dm.tDatosDe.Edit;
  F := application.findcomponent('formElementoAccion') as TForm;
  if Assigned(F) then
      f.showmodal
  else
  begin
    application.createform(tformElementoAccion, formElementoAccion);
    formElementoAccion.showmodal;
  end;
end;

procedure TformMenuPrincipal.actEliminarExecute(Sender: TObject);
var
  accion : string;
  datosAccion, clave, claveValor, claveRootkey : string;
  numeroEliminados, numeroNoEliminados : integer;
  eliminadaClave : boolean;
begin
  dbNavegadorResultado.Visible := false;
  actMarcar.Enabled := false;
  actDesmarcarTodo.Enabled := false;
  actSeleccionarTodos.Enabled := false;
  actDesmarcar.Enabled := false;
  actEliminar.Enabled := false;
  tabResultado.Show;
  lInfo.Caption := 'Iniciando eliminacin de software malicioso...';
  linfo.Refresh;
  //abrimos las tablas
  dm.tDatosDeResultado.Open;
  bp.Visible := true;
  bp.Min := 0;
  bp.Max := dm.tDatosDeResultado.RecordCount;
  bp.Position := 0;
  bp.Refresh;
  Refresh;

  numeroEliminados := 0;
  numeroNoEliminados := 0;
  dm.tDatosDeResultado.First;
  while not dm.tDatosDeResultado.Eof do
  begin
    bp.Position := dm.tDatosDeResultado.RecNo;
    bp.Refresh;
    if dm.tDatosDeResultadoEliminar.Value = True then
    begin
      lInfo.Caption := 'Eliminando ' + dm.tDatosDeResultadoNombre.Value;
      lInfo.Refresh;
      if not varisnull(dm.tDatosDeResultadoAccion.Value) then
        accion := dm.tDatosDeResultadoAccion.Value
      else
        accion := '';
      if not varisnull(dm.tDatosDeResultadoDatoAccion.Value) then
        datosAccion := dm.tDatosDeResultadoDatoAccion.Value
      else
        datosAccion := '';

      if (accion = 'Buscar Fichero') or (accion = 'Buscar Fichero (exaustivo)') or
          (accion = 'Buscar Cookie') or (accion = 'Buscar Favoritos (URL)') or
          (accion = 'Buscar Fichero (carpeta del sistema)') then
      begin
        if FileExists (datosaccion) then
        begin
          if not opPapeleraReciclaje.Checked then
          begin
            if DeleteFile(datosAccion) then
            begin
              numeroEliminados := numeroEliminados + 1;
              dm.tDatosDeResultado.Edit;
              dm.tDatosDeResultado.FieldByName('Eliminado').Value := True;
              dm.tDatosDeResultado.Post;
            end
            else
            begin
              dm.tDatosDeResultado.Edit;
              dm.tDatosDeResultado.FieldByName('Eliminado').Value := False;
              dm.tDatosDeResultado.Post;
              numeroNoEliminados := numeroNoEliminados + 1;
            end;
          end
          else //enviar a la Papelera de reciclaje NO TERMINADO
          begin

          end;
        end;
      end;

      if (accion = 'Buscar Carpeta') or (accion = 'Buscar Carpeta (exaustivo)')
          or (accion = 'Buscar Favoritos (Carpeta)') or
          (accion = 'Buscar Carpeta (carpeta del sistema)') then
      begin
        if DirectoryExists (datosaccion) then
        begin
          //eliminar carpeta completa
          if not opPapeleraReciclaje.Checked then
          begin
            if RemoveDir(datosAccion) then
            begin
              numeroEliminados := numeroEliminados + 1;
              dm.tDatosDeResultado.Edit;
              dm.tDatosDeResultadoEliminado.Value := true;
              dm.tDatosDeResultado.Post;
            end
            else
            begin
              numeroNoEliminados := numeroNoEliminados + 1;
              dm.tDatosDeResultado.Edit;
              dm.tDatosDeResultadoEliminado.Value := False;
              dm.tDatosDeResultado.Post;
            end;
          end
          else //enviar a la Papelera de Reciclaje NO TERMINADO
          begin
          end;
        end;
      end;

      if accion = 'Buscar Clave Registro' then
      begin
        if not varisnull(dm.tDatosDeResultado.FieldByName('RootKey').Value) then
          claveRootkey := dm.tDatosDeResultado.FieldByName('RootKey').Value
        else
          claveRootkey := '';
        if not varisnull(dm.tDatosDeResultado.FieldByName('Clave').Value) then
          clave := dm.tDatosDeResultado.FieldByName('Clave').Value
        else
          clave := '';
        if not varisnull(dm.tDatosDeResultado.FieldByName('ClaveValor').Value) then
          claveValor := dm.tDatosDeResultado.FieldByName('ClaveValor').Value
        else
          claveValor := '';
        with TRegistry.Create do
        try
          if claveRootkey = 'HKEY_CLASSES_ROOT' then
            RootKey := HKEY_CLASSES_ROOT;
          if claveRootkey = 'HKEY_CURRENT_USER' then
            RootKey := HKEY_CURRENT_USER;
          if claveRootkey = 'HKEY_LOCAL_MACHINE' then
            RootKey := HKEY_LOCAL_MACHINE;
          if claveRootkey = 'HKEY_USERS' then
            RootKey := HKEY_USERS;
          if claveRootkey = 'HKEY_CURRENT_CONFIG' then
            RootKey := HKEY_CURRENT_CONFIG;
          //eliminaremos la clave completa
          eliminadaClave := false;
          if claveValor = '' then
            eliminadaClave := DeleteKey(clave);
          if (claveValor <> '') and (OpenKey(clave, false)) then
            eliminadaClave := DeleteValue(claveValor);
          if eliminadaClave then
          begin
            numeroEliminados := numeroEliminados + 1;
            dm.tDatosDeResultado.Edit;
            dm.tDatosDeResultadoEliminado.Value := True;
            dm.tDatosDeResultado.Post;
          end
          else
          begin
            numeroNoEliminados := numeroNoEliminados + 1;
            dm.tDatosDeResultado.Edit;
            dm.tDatosDeResultadoEliminado.Value := False;
            dm.tDatosDeResultado.Post;
          end;
          CloseKey;
        finally
          free;
        end;
      end;

      if accion = 'Buscar Proceso' then
      begin

      end;

      if accion = 'Buscar Ventana' then
      begin

      end;
      if (numeroNoEliminados > 0) then
      begin
        be.Panels[1].Text := inttostr(numeroNoEliminados) + ' elementos maliciosos NO eliminados';
        be.Refresh;
      end;
      if (numeroEliminados > 0) and (numeroNoEliminados = 0) then
      begin
        be.Panels[1].Text := inttostr(numeroEliminados) + ' elementos maliciosos eliminados.';
        be.Refresh;
      end;
    end;
    dm.tDatosDeResultado.Next;
  end;
  dm.tDatosDeResultado.Refresh;
  if (numeroEliminados > 0) and (numeroNoEliminados > 0) then
  begin
    lInfo.Caption := 'Eliminados: ' + inttostr(numeroEliminados) +
        '.  No eliminados: ' + inttostr(numeroNoEliminados);
    lInfo.Font.Color := clRed;
  end;
  if (numeroEliminados > 0) and (numeroNoEliminados = 0) then
  begin
    lInfo.Caption := 'El proceso ha finalizado. Se han eliminado: ' +
        inttostr(numeroEliminados) + ' elementos maliciosos';
    lInfo.Font.Color := clGreen;
  end;
  if (numeroEliminados = 0) and (numeroNoEliminados > 0) then
  begin
    lInfo.Caption := 'No se ha eliminado ningn elemento';
    lInfo.Font.Color := clRed;
  end;
  if numeroNoEliminados > 0 then
  begin
    dbNavegadorResultado.Visible := true;
    actMarcar.Enabled := true;
    actDesmarcarTodo.Enabled := true;
    actSeleccionarTodos.Enabled := true;
    actDesmarcar.Enabled := true;
    actEliminar.Enabled := true;
  end;
  lInfo.Refresh;
  bp.Visible := false;
end;

procedure TformMenuPrincipal.actDesmarcarTodoExecute(Sender: TObject);
begin
  dm.tc.Close;
  dm.tc.SQL.Clear;
  dm.tc.SQL.Add('UPDATE DatosDetalleResultado SET Eliminar=False');
  dm.tc.ExecSQL;
  dm.tDatosDeResultado.Refresh;
end;

procedure TformMenuPrincipal.actMarcarExecute(Sender: TObject);
begin
  dm.tDatosDeResultado.Edit;
  dm.tDatosDeResultadoEliminar.Value := True;
  dm.tDatosDeResultado.Post;
end;

procedure TformMenuPrincipal.actDesmarcarExecute(Sender: TObject);
begin
  dm.tDatosDeResultado.Edit;
  dm.tDatosDeResultadoEliminar.Value := False;
  dm.tDatosDeResultado.Post;
end;

procedure TformMenuPrincipal.actResultadoExecute(Sender: TObject);
begin
  tabResultado.Show;
end;

end.
