unit UnidadModuloDatos;

interface

uses
  SysUtils, Classes, DB, DBTables, dialogs;

type
  Tdm = class(TDataModule)
    dtDatos: TDataSource;
    tDatos: TTable;
    DB: TDatabase;
    tDatosDe: TTable;
    dtDatosDe: TDataSource;
    tc: TQuery;
    tDatosDeResultado: TTable;
    dtDatosDeResultado: TDataSource;
    tDatosCodigo: TStringField;
    tDatosNombre: TStringField;
    tDatosNombreInterno: TStringField;
    tDatosRutaFichero: TStringField;
    tDatosFabricante: TStringField;
    tDatosDerechosDeCopia: TStringField;
    tDatosNombreVentana: TStringField;
    tDatosFecha: TDateField;
    tDatosFechaActualizacion: TDateField;
    tDatosVersion: TStringField;
    tDatosEfectos: TStringField;
    tDatosOtrosDatos: TStringField;
    tDatosDeCodigo: TStringField;
    tDatosDeCodigoDato: TStringField;
    tDatosDeAccion: TStringField;
    tDatosDeDatoAccion: TStringField;
    tDatosDeRootkey: TStringField;
    tDatosDeClave: TStringField;
    tDatosDeClaveValor: TStringField;
    tDatosDeResultadoCodigoDato: TStringField;
    tDatosDeResultadoAccion: TStringField;
    tDatosDeResultadoDatoAccion: TStringField;
    tDatosDeResultadoRootkey: TStringField;
    tDatosDeResultadoClave: TStringField;
    tDatosDeResultadoClaveValor: TStringField;
    tDatosDeResultadoEliminar: TBooleanField;
    tDatosDeResultadoEliminado: TBooleanField;
    tDatosDeResultadoNombre: TStringField;
    dtDatosDe2: TDataSource;
    tDatosDe2: TTable;
    StringField1: TStringField;
    StringField2: TStringField;
    StringField3: TStringField;
    StringField4: TStringField;
    StringField5: TStringField;
    StringField6: TStringField;
    StringField7: TStringField;
    tDatosDeCarpetaSistema: TStringField;
    procedure tDatosAfterPost(DataSet: TDataSet);
    procedure tDatosDeAfterDelete(DataSet: TDataSet);
    procedure tDatosDeResultadoAfterDelete(DataSet: TDataSet);
    procedure dtDatosDataChange(Sender: TObject; Field: TField);
    procedure tDatosDe2AfterDelete(DataSet: TDataSet);
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dm: Tdm;

implementation

uses UnidadMenuPrincipal;

{$R *.dfm}

procedure Tdm.tDatosAfterPost(DataSet: TDataSet);
begin
  tDatos.FlushBuffers;
end;

procedure Tdm.tDatosDeAfterDelete(DataSet: TDataSet);
begin
  tDatosDe.FlushBuffers;
end;

procedure Tdm.tDatosDeResultadoAfterDelete(DataSet: TDataSet);
begin
  tDatosDeResultado.FlushBuffers;
end;

procedure Tdm.dtDatosDataChange(Sender: TObject; Field: TField);
begin
  if (tDatos.State <> dsinsert) and (tDatos.State <> dsedit) then
  begin
    tDatosDe.Filtered := false;
    formmenuprincipal.lNum.Caption := 'N Elementos: ' + inttostr(dm.tDatos.RecordCount) +
      '  N acciones: ' + inttostr(dm.tDatosDe.RecordCount);
    tDatosDe.Filter := '[CodigoDato]=' + QuotedStr(tdatos.fieldbyname('Codigo').Value);
    tDatosDe.Filtered := true;
    formmenuprincipal.lNumDe.Caption := 'N acciones elemento: ' + inttostr(dm.tDatosDe.RecordCount);
  end;
end;

procedure Tdm.tDatosDe2AfterDelete(DataSet: TDataSet);
begin
  tDatosDe2.FlushBuffers;
end;

procedure Tdm.DataModuleCreate(Sender: TObject);
begin
  With DB do
  begin
    Close;
    Params.Clear;
    Params.Add('PATH=' + ExtractFilePath(ParamStr(0)) + 'datos');
    Params.Add('DEFAULT DRIVER=PARADOX');
    Params.Add('ENABLE BCD=FALSE');
    Connected := true;
  End;
end;

end.
